module Stuka

  class Domain

    def initialize
      self.class.define_basic_methods()
    end

    def get_binding
      binding()
    end

    def self.define_basic_methods()
      subclass = self
      subclass::ATTRS.each do |arg_name|
        next if subclass.method_defined? arg_name.to_sym
        subclass.send(:define_method, arg_name.to_sym) do |arg = nil|
          if arg
            instance_variable_set("@#{arg_name}".to_sym, arg)
          else
            instance_variable_get("@#{arg_name}")
          end
        end
      end
    end

  end

end