require "stuka/commands/command"
require "stuka/commands/subcommands/create/create_project"

module Stuka

  class NewCommand < Command
    
    argument :name, :desc => "Name of the project"

    def execute
      Stuka::CreateProject.new.create(name)
    end
    
    def self.description
      "generates a project skeleton"
    end

    def self.usage
      "new NAME"
    end

  end

end