require "stuka/commands/command"

module Stuka

  class SetupConfig < Command

    def setup
      config_exists = File.file?("#{Dir.pwd}/stuka_config.rb")

      if config_exists
        say("\tConfig already setup")
        return
      end

      template('templates/configs/stuka_config.tt', "stuka_config.rb")
      say("\tconfig file (stuka_config.rb) setup")
    end

  end

end