require "stuka/commands/command"

module Stuka

  class SetupGemfile < Command

    def setup
      gemfile_exists = File.file?("#{Dir.pwd}/Gemfile")

      if gemfile_exists
        say("\tGemfile already setup")
        return
      end

      template('templates/configs/gemfile.tt', "Gemfile")
      say("\tGemfile setup, run bundle or bundle install --path vendor/bundle")
    end

  end

end