require "stuka/commands/command"

module Stuka

  class SetupRakefile < Command

    def setup
      rake_file_exists = File.file?("#{Dir.pwd}/Rakefile")

      if rake_file_exists
        say("Rakefile already setup")
        return
      end

      template('templates/configs/rakefile.tt', "Rakefile")
    end

  end

end