require "stuka/commands/command"

module Stuka

  class SetupTasks < Command

    def setup
      tasks_file_exists = File.file?("#{Dir.pwd}/lib/stuka.rake")

      if tasks_file_exists
        say("Stuka tasks already setup")
        return
      end

      template('templates/tasks/stuka.tt', "lib/tasks/stuka.rake")
    end

  end

end