require 'stuka/config/stuka_paths'

module Stuka

  class ProcessCleaner

    def self.gather_process_files
      Dir["#{Stuka::StukaPaths.processes_source_path}/*.rb"]
    end

    def self.clean
      files = gather_process_files
      files.each do |path|
        File.delete(path)
      end
    end 

  end

end
